@ECHO OFF
SETLOCAL

REM Download source, libs, etc (see urls below)
REM   Extract waon
REM   Put the libs in subdirs of that location
REM   Edit paths below to match your system
REM Patch the code
REM   patch.exe < waon_mingw.patch
REM Run this script to build an executable


REM Required lib files:
REM   fftw3.h libfftw3-3.dll
REM   sndfile.h libsndfile-1.dll
REM   ftp://ftp.fftw.org/pub/fftw/fftw-3.2.2.pl1-dll32.zip
REM   http://www.mega-nerd.com/libsndfile/files/libsndfile-1.0.21-w32-setup.exe

REM Required waon files:
REM   analyse.c analyse.h fft.c fft.h hc.c hc.h
REM   main.c memory-check.h midi.c midi.h notes.c notes.h
REM   snd.c snd.h VERSION.h
REM   http://hivelocity.dl.sourceforge.net/project/waon/waon/0.9/waon-0.9.tar.gz

REM Required tools:
REM   mingw patch.exe
REM     http://superb-sea2.dl.sourceforge.net/project/gnuwin32/patch/2.5.9-7/patch-2.5.9-7-bin.zip
REM   mingw compiler (wxDev-Cpp is overkill, but prepackages bin/includes)
REM     http://wxdsgn.sourceforge.net/


REM Paths to headers
SET i-mingw=D:/Apps/Dev-Cpp/include
SET i-fftw=./fftw-3.2.2.pl1-dll32
SET i-libsndfile=./libsndfile-1.0.21

REM Paths to libs
SET l-mingw=D:/Apps/Dev-Cpp/lib
SET dll-fftw=./fftw-3.2.2.pl1-dll32/libfftw3-3.dll
SET dll-libsndfile=./libsndfile-1.0.21/libsndfile-1.dll

REM Paths to tools
SET p-mingw-bin=D:\Apps\Dev-Cpp\bin
SET PATH=%p-mingw-bin%;%PATH%

gcc -Wall -march=pentium -O3 -ffast-math -I"%i-mingw%" -I"%i-fftw%" -I"%i-libsndfile%" -L"%l-mingw%" -L"%l-fftw%" -lm "%dll-fftw%" "%dll-libsndfile%" -o waon analyse.c fft.c hc.c main.c midi.c notes.c snd.c

ENDLOCAL
EXIT /B
